var POS_WEBSERVICE_URL = 'k2service.php';
var CONFIG_FILE = 'default.iec';

function activateTabCore(pageId)
{
	var pageToActivate = document.getElementById(pageId);
	var tabCtrl = pageToActivate.parentNode;
	var cnt = tabCtrl.children.length;
	for (var i = 0; i < cnt; i++)
	{
		var node = tabCtrl.children[i];
		node.style.display = (node == pageToActivate) ? 'block' : 'none';
	}
}
function showError(err, isError = true)
{
	var e = document.getElementById('errorFunc');
	e.className = isError ? 'alert-danger' : 'alert-success';
	e.innerHTML = err;
	e.hidden = '';
}
function interfaceReturn(res)
{
	var e = document.getElementById('actionResult');
	var err = (res.substring(0, 1) != '0');
	e.value = res.substring(1);
	e.className = err ? 'alert-danger' : 'alert-success';
	e.hidden = '';
}
function saveCfg(showOk = true)
{
	var e = document.getElementById('errorFunc');
	e.hidden = 'hidden';
	var cfg = new Config();
	if (cfg.groups !== undefined)
	{
		if ((cfg.groups.fields.length == 0) || (cfg.articles.fields.length == 0))
		{
			return false;
		}
	}

	var c = cfg.toJson();
	var addr = POS_WEBSERVICE_URL + '?a=3';
	var resp = $.ajax
	(
		{
			type: 'POST',
			url: addr,
			data:
			{
				'file' : CONFIG_FILE,
				'content' : c
			},
			success: function(data)
			{
				error = data;
			},
			complete: function()
			{
				if (error != '')
				{
					showError(error, true);
					return;
				}
				if (showOk)
				{
					showError('Zapisano ...', false);
				}
			}
		}
	);
}
function fillCommon(cfg)
{
	document.getElementById('cacheTime').value = cfg.cacheTime;
}
function saveCommon(cfg)
{
	cfg.cacheTime = document.getElementById('cacheTime').value;
}class Integrator
{
	
	constructor()
	{
		this.url = document.getElementById('integratorUrl').value;
		this.clientCode = document.getElementById('clientCode').value;
		this.serialNo = document.getElementById('serialNo').value;
	}
	
}
class Ftp
{
	
	constructor()
	{
		this.url = document.getElementById('ftpUrl').value;
		this.user = document.getElementById('ftpUser').value;
		this.pwd = document.getElementById('ftpPwd').value;
		this.folder = document.getElementById('ftpFolder').value;
	}
	
}

function fillIntegrator(cfg, b64)
{
	if (cfg == null)
	{
		return;
	}
	document.getElementById('integratorUrl').value = cfg.url;
	document.getElementById('clientCode').value = cfg.clientCode;
	document.getElementById('serialNo').value = b64.decode(cfg.serialNo);
}
function checkIntegrator()
{
	var e = document.getElementById('errorFunc');
	e.hidden = 'hidden';
	saveCfg(false);
	setTimeout
	(
		function()
		{
			if (e.hidden == '')
			{
				return
			}
			$.ajax
			(
				{
					type: 'GET',
					url: POS_WEBSERVICE_URL + '?a=0',
					success: function(data)
					{
						error = data;
					},
					complete: function()
					{
						if (error != '')
						{
							showError(error);
							return;
						}
						showError('Dane dostępu do integratora są poprawne!', false);
					}
				}
			)
		},
		250
	);
}
function fillFtp(cfg, b64)
{
	if (cfg == null)
	{
		return;
	}
	document.getElementById('ftpUrl').value = cfg.url;
	document.getElementById('ftpUser').value = cfg.user;
	document.getElementById('ftpPwd').value = b64.decode(cfg.pwd);
	document.getElementById('ftpFolder').value = cfg.folder;
}
function checkFtp()
{
	var e = document.getElementById('errorFunc');
	e.hidden = 'hidden';
	saveCfg(false);
	setTimeout
	(
		function()
		{
			if (e.hidden == '')
			{
				return
			}
			$.ajax
			(
				{
					type: 'GET',
					url: POS_WEBSERVICE_URL + '?a=1',
					success: function(data)
					{
						error = data;
					},
					complete: function()
					{
						if (error != '')
						{
							showError(error, true);
							return;
						}
						showError('Dane dostępu do serwera FTP są poprawne!', false);
					}
				}
			);
		},
		250
	);
}
function createIntegratorConfig(cfg)
{
	cfg.integrator = new Integrator();
	if (document.getElementById('ftpUrl'))
	{
		cfg.ftp = new Ftp();
	}	
}class Lilou
{
	
	constructor()
	{
		this.url = document.getElementById('lilouUrl').value;
		this.user = document.getElementById('lilouUser').value;
		this.pwd = document.getElementById('lilouPwd').value;
		this.receiptType = document.getElementById('lilouReceiptType').value;
		var t = document.getElementById('table_dt');
		if (t != undefined)
		{
			this.options = {};
			var docTypes = [];
			var rc = t.rows.length;
			for (var i = 0; i < rc - 2; i++)
			{
				var dt = {};
				dt[document.getElementById('DTK' + String(i)).value] = document.getElementById('DTV' + String(i)).value;
				docTypes.push(dt);
			}
			this.options.docTypes = docTypes;
			
			t = document.getElementById('table_pt');
			var paymentTypes = [];
			rc = t.rows.length;
			for (var i = 0; i < rc - 2; i++)
			{
				var pt = {};
				var ptv = {};
				ptv[document.getElementById('PTS' + String(i)).value] = document.getElementById('PTN' + String(i)).value;
				pt[document.getElementById('PTK' + String(i)).value] = ptv;
				paymentTypes.push(pt);
			}
			this.options.paymentTypes = paymentTypes;
			
			t = document.getElementById('table_st');
			var stores = [];
			var rc = t.rows.length;
			for (var i = 0; i < rc - 2; i++)
			{
				var st = {};
				st[document.getElementById('STK' + String(i)).value] = document.getElementById('STV' + String(i)).value;
				stores.push(st);
			}
			this.options.stores = stores;
		}
		else
		{
			var options = document.getElementById('options');
			this.options = JSON.parse(options.value);
		}
	}
	
}
function fillLilou(cfg, b64)
{
	if (cfg == undefined)
	{
		document.getElementById('lilouReceiptType').value = 'PA';
	}
	else
	{
		document.getElementById('lilouUrl').value = cfg.url;
		document.getElementById('lilouUser').value = cfg.user;
		document.getElementById('lilouPwd').value = b64.decode(cfg.pwd);
		document.getElementById('lilouReceiptType').value = cfg.receiptType;
	}
	
}
function createLilouConfig(cfg)
{
	cfg.lilou = new Lilou();
}
function doLilouImportDoc(callback)
{
	var d = new Date();
	d.setTime(d.getTime() + 3000);
	var s = d.toGMTString();	
	document.cookie = 'cfg_file=default.iec;expires=' + s;
	var addr = POS_WEBSERVICE_URL + '?a=8';
	var resp = $.ajax
	(
		{
			type: 'GET',
			url: addr,
			success: function(data)
			{
				callback(data);
			}
		}
	);
}		
function lilouImportDoc()
{
	var e = document.getElementById('actionResult');
	e.hidden = 'hidden';
	var ef = document.getElementById('errorFunc');
	saveCfg(false);
	setTimeout
	(
		function()
		{
			if (ef.hidden == '')
			{
				return;
			}
			e.className = 'wait';
			e.value = '... TRWA IMPORT DOKUMENTÓW DO INTEGRATORA...';
			e.hidden = '';
			doLilouImportDoc(interfaceReturn);
		},
		250
	);
}
function checkLilouWebService()
{
	var e = document.getElementById('errorFunc');
	e.hidden = 'hidden';
	saveCfg(false);
	setTimeout
	(
		function()
		{
			if (e.hidden == '')
			{
				return
			}
			$.ajax
			(
				{
					type: 'GET',
					url: POS_WEBSERVICE_URL + '?a=9',
					success: function(data)
					{
						error = data;
					},
					complete: function()
					{
						if (error != '')
						{
							showError(error);
							return;
						}
						showError('Dane dostępu do web serwisu Lilou są poprawne!', false);
					}
				}
			);
		},
		250
	);
}function PageLoaded()
{
	var Base64={_keyStr:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",encode:function(e){var t="";var n,r,i,s,o,u,a;var f=0;e=Base64._utf8_encode(e);while(f<e.length){n=e.charCodeAt(f++);r=e.charCodeAt(f++);i=e.charCodeAt(f++);s=n>>2;o=(n&3)<<4|r>>4;u=(r&15)<<2|i>>6;a=i&63;if(isNaN(r)){u=a=64}else if(isNaN(i)){a=64}t=t+this._keyStr.charAt(s)+this._keyStr.charAt(o)+this._keyStr.charAt(u)+this._keyStr.charAt(a)}return t},decode:function(e){var t="";var n,r,i;var s,o,u,a;var f=0;e=e.replace(/[^A-Za-z0-9\+\/\=]/g,"");while(f<e.length){s=this._keyStr.indexOf(e.charAt(f++));o=this._keyStr.indexOf(e.charAt(f++));u=this._keyStr.indexOf(e.charAt(f++));a=this._keyStr.indexOf(e.charAt(f++));n=s<<2|o>>4;r=(o&15)<<4|u>>2;i=(u&3)<<6|a;t=t+String.fromCharCode(n);if(u!=64){t=t+String.fromCharCode(r)}if(a!=64){t=t+String.fromCharCode(i)}}t=Base64._utf8_decode(t);return t},_utf8_encode:function(e){e=e.replace(/\r\n/g,"\n");var t="";for(var n=0;n<e.length;n++){var r=e.charCodeAt(n);if(r<128){t+=String.fromCharCode(r)}else if(r>127&&r<2048){t+=String.fromCharCode(r>>6|192);t+=String.fromCharCode(r&63|128)}else{t+=String.fromCharCode(r>>12|224);t+=String.fromCharCode(r>>6&63|128);t+=String.fromCharCode(r&63|128)}}return t},_utf8_decode:function(e){var t="";var n=0;var r=c1=c2=0;while(n<e.length){r=e.charCodeAt(n);if(r<128){t+=String.fromCharCode(r);n++}else if(r>191&&r<224){c2=e.charCodeAt(n+1);t+=String.fromCharCode((r&31)<<6|c2&63);n+=2}else{c2=e.charCodeAt(n+1);c3=e.charCodeAt(n+2);t+=String.fromCharCode((r&15)<<12|(c2&63)<<6|c3&63);n+=3}}return t}}

	POS_WEBSERVICE_URL = 'webservice/lilou';
	CONFIG_FILE = '../../../Customers/Lilou/default.iec';
	
	var e = document.getElementById('error');
	if (e != null)
	{
		return;
	}
	var cfg = document.getElementById('cfg_file');
	if (cfg == null)
	{
		return;
	}

	cfg = JSON.parse(cfg.value);
	
	fillCommon(cfg);
	fillIntegrator(cfg.integrator, Base64);
	fillFtp(cfg.ftp, Base64);
	fillLilou(cfg.lilou, Base64);
}
class Config
{
	
	constructor()
	{
		saveCommon(this);
		createIntegratorConfig(this);
		createLilouConfig(this);
	}
	
	toJson()
	{
		return JSON.stringify(this);
	}
	
	toCookie()
	{
		return encodeURIComponent(this.toJson());
	}
	
}		
