Report =
{
	SetSettings: function(url)
	{
		if ($('[name=ReportStore]').length)
		{
			document.location = url + '?store=' + $('[name=ReportStore]').val()
		}
		else
		{
			var c = $('.UI-ReportNavigator input')

			document.location = url + '?from=' + $(c[0]).val() + '&to=' + $(c[1]).val() + '&store=' + ($('#store-container').is(':visible') ? storeIDs.join(',') : '') + '&district=' + districtIDs.join(',') + '&channel=' + $('[data-name=Channel]').data('value')

			return false
		}
	},
	
	EditData: function(options)
	{
		if (!options)
		{
			options = {
				date: $('[name=ReportDateFrom]').val(),
				store: $('.store-ids input:checked:first').val(),
				counter: 0
			}
		}
		
		$('#EditDataDialog .modal-body').load('/report/editdata?action=load&date=' + options.date + '&store=' + options.store + '&counter=' + options.counter, function() {
			if (jQuery().datetimepicker)
			{
				$('#EditDataDialog [data-widget=datepicker]').datetimepicker({ pickTime: false, language: 'pl' })
			}
			else if (jQuery().datepicker)
			{
				$('#EditDataDialog [data-widget=datepicker]').datepicker({ format: 'yyyy-mm-dd', language: 'pl' })
			}
			
			$('#EditDataDialog').modal('show')
		})
	},
	
	SaveData: function()
	{
		var data = {}, fields = $('#EditDataDialog table input[type=number]'), field, i
		
		for (i = 0; i < fields.length; i++)
		{
			field = $(fields[i])
			
			data[field.data('id')] = field.val()
		}
		
		$.ajax
		({
			url: '/report/editdata?action=save&date=' + $('#EditDataDialog [name=Date]').val() + '&store=' + $('#EditDataDialog [name=Store]').val() + '&counter=' + $('#EditDataDialog [name=Counter]').val(),
			type: 'POST',
			dataType: 'json',
			data: data,
			success: function(data)
			{
				if (data.message)
				{
					alert(data.message)
				}
			}
		})
	}
}

var storeIDs = [], districtIDs = []

$
(
	function()
	{
		$('#Report-EMail').click(function() {
			bootbox.setLocale('pl')
			url = $(this).attr('data-url')
			bootbox.prompt('Podaj adres e-mail', function(result) {
				if (result) {
					$.get(url + result.trim())
				}
			})

			return false
		})
		
		var inputs = $('.store-ids input:checked'), i
		
		for (i = 0; i < inputs.length; i++) {
			storeIDs.push($(inputs[i]).val())
		}
		
		$('.store-ids .unselectable').click(function(event) {
			event.stopPropagation()
		})
		
		$('.store-ids .select-all').click(function(event) {
			var inputs = $('.store-ids input'), i
			
			storeIDs = [0]
			
			for (i = 0; i < inputs.length; i++) {
				storeIDs.push($(inputs[i]).val())
			}

			inputs.prop('checked', true)
		})

		$('.store-ids .deselect-all').click(function(event) {
			$('.store-ids input').prop('checked', null)
			
			storeIDs = [0]
		})

		$('.store-ids a' ).click(function(event) {
			var $target = $(event.currentTarget), $inp = $target.find('input'), val = $inp.val(), idx

			if ((idx = storeIDs.indexOf(val)) > -1) {
				storeIDs.splice(idx, 1)
				setTimeout(function() { $inp.prop( 'checked', false ) }, 0)
			} else {
				storeIDs.push(val)
				setTimeout(function() { $inp.prop( 'checked', true ) }, 0)
			}

			$(event.target).blur()
			
			return false
		})
		
		inputs = $('.district-ids input:checked')
		
		for (i = 0; i < inputs.length; i++) {
			districtIDs.push($(inputs[i]).val())
		}
		
		$('.district-ids a' ).click(function(event) {
			var $target = $(event.currentTarget), $inp = $target.find('input'), val = $inp.val(), idx

			if ((idx = districtIDs.indexOf(val)) > -1) {
				districtIDs.splice(idx, 1)
				setTimeout(function() { $inp.prop( 'checked', false ); if (!districtIDs.length) $('#store-container').fadeIn().css('display', 'inline-block') }, 0)
			} else {
				districtIDs.push(val)
				setTimeout(function() { $inp.prop( 'checked', true ); $('#store-container').fadeOut() }, 0)
			}

			$(event.target).blur()
			
			return false
		})

	}
)