#!/usr/bin/perl

use DBI;
use Switch;
use Cwd qw(abs_path);
use File::Basename qw(dirname);
 
# TODO wykonywanie operacji dla wszytkich baz - oczyt baz z katalogów w Settings

# plik z danymi do połączenia z bazą k2online
$file = '../../Settings/demo/Database.xml';

my $path = dirname(abs_path($0));
chdir($path);

# odczytanie danych do połączenia z bazą k2online
open (F, $file) || die ("Could not open $file!");
while ($line = <F>){
	@pole = split(/[;<>:]/, $line);
	foreach (@pole) {
		@pole2 = split(/=/, $_);
		switch (@pole2[0]) {
			case "host" {$db_host = @pole2[1]}
			case "port" {$db_port = @pole2[1]}
			case "dbname" {$db_name = @pole2[1]}
			case "user" {$db_user = @pole2[1]}
			case "password" {$db_pass = @pole2[1]}
		}
	}
}
close (F);

my $dbh_pg = DBI->connect("dbi:Pg:dbname=${db_name};host=${db_host};port=${db_port}", $db_user, $db_pass, {RaiseError => 1, PrintError => 0}) or die "Error $DBI::errstr\n";
my $dbh_pg_2 = DBI->connect("dbi:Pg:dbname=${db_name};host=${db_host};port=${db_port}", $db_user, $db_pass, {RaiseError => 1, PrintError => 0}) or die "Error $DBI::errstr\n";

$query_pg = "select wy02.id_klucza, wy02.email, email_tytul, tekst_wiadomosci, nazwa_kontrahenta, nazwa_kontrahenta_dodatkowa from wy02 join wy01 on wy02.id_klucza_tekstu_wiadomosci=wy01.id_klucza join kh01 on wy02.id_kontrahenta=kh01.id_kontrahenta where wy02.telefon is NULL and status_wyslania=0 limit 5";
$sth_pg = $dbh_pg->prepare($query_pg) or die "Error prepare: $dbh_pg->errstr()\n";
$sth_pg->execute() or die "Error execute: $sth_pg->errstr()\n";

while (@row_pg = $sth_pg->fetchrow_array()) {
	
	open (M, '>', "$path/$row_pg[0]") || die ("Could not open $row_pg[0]!");
	print M "From: K2online <no-reply\@k2online.pl>\n";
	print M "To: $row_pg[4] $row_pg[5] <$row_pg[1]>\n";
	print M "Subject: $row_pg[2]\n";
	print M "MIME-Version: 1.0\n";
	print M "Content-Type: text/html; charset=utf-8\n\n";
	print M "$row_pg[3]";
	close (M);

	$exit_status = system("cat $path/$row_pg[0] | msmtp -X $path/$row_pg[0].log -C $path/msmtprc $row_pg[1]");
	
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
	$now = sprintf("%04d-%02d-%02d %02d:%02d:%02d", $year+1900, $mon+1, $mday, $hour, $min, $sec);
	
	if ($exit_status == 0) {
		$query_pg_2 = "update wy02 set status_wyslania=2, data_wyslania='$now' where id_klucza='$row_pg[0]'";
		$sth_pg_2 = $dbh_pg_2->prepare($query_pg_2) or die "Error prepare: $dbh_pg->errstr()\n";
		$sth_pg_2->execute() or die "Error execute: $sth_pg->errstr()\n";
	} else {
		$query_pg_2 = "update wy02 set status_wyslania=3 where id_klucza='$row_pg[0]'";
		$sth_pg_2 = $dbh_pg_2->prepare($query_pg_2) or die "Error prepare: $dbh_pg->errstr()\n";
		$sth_pg_2->execute() or die "Error execute: $sth_pg->errstr()\n";
	}
}

$sth_pg->finish();
$dbh_pg->disconnect();

$sth_pg_2->finish();
$dbh_pg_2->disconnect();
