#!/usr/bin/perl

use DBI;
use Switch;
use Cwd qw(abs_path);
use File::Basename qw(dirname);
use LWP::UserAgent;

my $path = dirname(abs_path($0));
chdir($path);

$path = '../../Settings/';

# wykonanie dla wszytkicj katalogów w "../../Settings/"
opendir( my $DIR, $path );
while ( my $entry = readdir $DIR ) {
    next unless -d $path . '/' . $entry;
    next if $entry eq '.' or $entry eq '..';
    print "Wysylka dla $entry\n";
	ToSmsApi_Send($entry);
}
closedir $DIR;


sub ToSmsApi_Send {

	# odczytanie danych do połączenia z bazą k2online
	$file = "../../Settings/$_[0]/Database.xml";
	
	open (F, $file) || die ("Could not open $file!");
	while ($line = <F>){
		@pole = split(/[;<>:]/, $line);
		foreach (@pole) {
			@pole2 = split(/=/, $_);
			switch (@pole2[0]) {
				case "host" {$db_host = @pole2[1]}
				case "port" {$db_port = @pole2[1]}
				case "dbname" {$db_name = @pole2[1]}
				case "user" {$db_user = @pole2[1]}
				case "password" {$db_pass = @pole2[1]}
			}
		}
	}
	close (F);

	my $dbh_pg = DBI->connect("dbi:Pg:dbname=${db_name};host=${db_host};port=${db_port}", $db_user, $db_pass, {RaiseError => 1, PrintError => 0}) or die "Error $DBI::errstr\n";
	my $dbh_pg_2 = DBI->connect("dbi:Pg:dbname=${db_name};host=${db_host};port=${db_port}", $db_user, $db_pass, {RaiseError => 1, PrintError => 0}) or die "Error $DBI::errstr\n";

	### pobranie danych konfiguracyjnych SMSAPI
	$query_pg = "select wartosc from vw_konfiguracja_wszystkie_zmienne where nazwa_zmiennej='SMSAPIUser'";
	$sth_pg = $dbh_pg->prepare($query_pg) or die "Error prepare: $dbh_pg->errstr()\n";
	$sth_pg->execute() or die "Error execute: $sth_pg->errstr()\n";
	$sms_user=$sth_pg->fetchrow_array();
	
	$query_pg = "select wartosc from vw_konfiguracja_wszystkie_zmienne where nazwa_zmiennej='SMSAPIPass'";
	$sth_pg = $dbh_pg->prepare($query_pg) or die "Error prepare: $dbh_pg->errstr()\n";
	$sth_pg->execute() or die "Error execute: $sth_pg->errstr()\n";
	$sms_pass=$sth_pg->fetchrow_array();

	$query_pg = "select (case when wartosc = 'TRUE' then 1 else 0 end) as wartosc from vw_konfiguracja_wszystkie_zmienne where nazwa_zmiennej='SMSFast'";
	$sth_pg = $dbh_pg->prepare($query_pg) or die "Error prepare: $dbh_pg->errstr()\n";
	$sth_pg->execute() or die "Error execute: $sth_pg->errstr()\n";
	$sms_fast=$sth_pg->fetchrow_array();
	
	$query_pg = "select (case when wartosc = 'FALSE' then 0 else 1 end) as wartosc from vw_konfiguracja_wszystkie_zmienne where nazwa_zmiennej='SMSNormalize'";
	$sth_pg = $dbh_pg->prepare($query_pg) or die "Error prepare: $dbh_pg->errstr()\n";
	$sth_pg->execute() or die "Error execute: $sth_pg->errstr()\n";
	$sms_normalize=$sth_pg->fetchrow_array();
	
	$query_pg = "select wartosc from vw_konfiguracja_wszystkie_zmienne where nazwa_zmiennej='SMSAPIFrom'";
	$sth_pg = $dbh_pg->prepare($query_pg) or die "Error prepare: $dbh_pg->errstr()\n";
	$sth_pg->execute() or die "Error execute: $sth_pg->errstr()\n";
	$sms_from=$sth_pg->fetchrow_array();
	
	### pobranie SMS do wyslania z k2online ###
	$query_pg = "select telefon, tekst_wiadomosci, wy02.id_klucza from wy02 join wy01 on wy02.id_klucza_tekstu_wiadomosci=wy01.id_klucza where email is NULL and status_wyslania=0";
	$sth_pg = $dbh_pg->prepare($query_pg) or die "Error prepare: $dbh_pg->errstr()\n";
	$sth_pg->execute() or die "Error execute: $sth_pg->errstr()\n";

	while (@row_pg = $sth_pg->fetchrow_array()) {

		#usuniecie zbednych spacji
		$row_pg[1] =~ s/\s+/ /g;
		#print "$row_pg[1]" ."\n";
		
		#wyslanie smsa przez smsapi
		my $url="https://api.smsapi.pl/sms.do?username=$sms_user&password=$sms_pass&normalize=$sms_normalize&fast=$sms_fast&idx=$_[0]&encoding=utf-8&from=$sms_from&to=$row_pg[0]&message=$row_pg[1]";
		
		my $ua = LWP::UserAgent->new;
		$ua->agent($browser);
		my $rsp = $ua->get($url);
		@odpowiedz = split(/:/, $rsp->decoded_content);
		#print @odpowiedz[0] . "\n";
		#print @odpowiedz[1] . "\n";
		
		if (@odpowiedz[0] =~ /OK/) {
			# oznaczenie smsow w bazie k2online
			$query_pg_2 = "update wy02 set status_wyslania=1, id_obce=@odpowiedz[1] where id_klucza='$row_pg[2]'";
			$sth_pg_2 = $dbh_pg_2->prepare($query_pg_2) or die "Error prepare: $dbh_pg->errstr()\n";
			$sth_pg_2->execute() or die "Error execute: $sth_pg->errstr()\n";
		}
		
		if (@odpowiedz[0] =~ /ERROR/) {
			# oznaczenie smsow w bazie k2online
			$query_pg_2 = "update wy02 set status_wyslania=1, status_api=@odpowiedz[1] where id_klucza='$row_pg[2]'";
			$sth_pg_2 = $dbh_pg_2->prepare($query_pg_2) or die "Error prepare: $dbh_pg->errstr()\n";
			$sth_pg_2->execute() or die "Error execute: $sth_pg->errstr()\n";
		}

	}

	# zamkniecie polaczen do bazy

	if ($sth_pg) { $sth_pg->finish(); }
	if ($dbh_pg) { $dbh_pg->disconnect(); }
	
	if ($sth_pg_2) { $sth_pg_2->finish(); }
	if ($dbh_pg_2) { $dbh_pg_2->disconnect(); }
	
}	
